<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Thuongnh</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="../plugins/fontawesome-free/css/all.min.css">
  <!-- daterange picker -->
  <link rel="stylesheet" href="../plugins/daterangepicker/daterangepicker.css">
  <!-- Bootstrap Color Picker -->
  <link rel="stylesheet" href="../plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="../plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- font-awesome -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="../dist/css/adminlte.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- data table -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="../index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="../dist/img/thuong.jpg" alt="user Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="../dist/img/user8-128x128.jpg" alt="user Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="../dist/img/user3-128x128.jpg" alt="user Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="../index3.html" class="brand-link">
        <img src="../dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-customer img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">AdminLTE 3</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="customer">
            <img src="../dist/img/thuong.jpg" class="img-circle elevation-2" alt="user customer">
          </div>
          <div class="info">
            <a href="#" class="d-block">NGUYỄN HỮU THƯƠNG</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <!-- 1 -->
                <li class="nav-item">
                  <a href="./customers.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>CUSTOMER</p>
                  </a>
                </li>
                <!-- 2 -->
                <li class="nav-item">
                  <a href="./payments.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>PAYMENTS </p>
                  </a>
                </li>
                <!-- 3 -->
                <li class="nav-item">
                  <a href="./orders.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>ORDER</p>
                  </a>
                </li>
                <!-- 4 -->
                <li class="nav-item">
                  <a href="./order_details.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>ORDER DETAIL</p>
                  </a>
                </li>
                <!-- 5 -->
                <li class="nav-item">
                  <a href="./products.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>PRODUCT</p>
                  </a>
                </li>
                <!-- 6 -->
                <li class="nav-item">
                  <a href="./product_lines.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>PRODUCT LINE</p>
                  </a>
                </li>
                <!-- 7 -->
                <li class="nav-item">
                  <a href="./employees.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>EMPLOYEES</p>
                  </a>
                </li>
                <!-- 8 -->
                <li class="nav-item">
                  <a href="./offices.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>OFFICES</p>
                  </a>
                </li>
                <!-- 9 -->
                <li class="nav-item">
                  <a href="./HISTORY.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p> HISTORY CRUD</p>
                  </a>
                </li>

              </ul>
        </nav>
        <!-- /.sidebar-menu  -->
      </div>
      <!-- /.sidebar -->
    </aside>
    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">

      <!-- Main content -->
      <section class="content">
        <!-- Main content -->
        <!-- Main content -->
        <!-- Main content -->
        <div class="comtainer-fluid">
          <h1 class="text-center" style="background-color: white;">QUẢN LÝ CUSTOMER</h1>
        </div>
        <div class="comtainer-fluid">
          <div class="container">



            <div class="row">
              <div class="col-sm-2">
                <button id="btn-them-customer" class=" btn btn-success ">
                  <i class="fa-solid fa-plus"></i> Thêm
                </button>
              </div>
            </div>
          </div>
        </div>
        <!-- data table -->
        <div class="comtainer-fluid mt-5">
          <table id="table-lich-su-hoc-tap" class="table table-striped table-hover table-bordered">
            <thead>
              <tr>
                <th>STT</th>
                <th>last name</th>
                <th>first name</th>
                <th>phone number</th>
                <th>address</th>
                <th>city</th>
                <th>state</th>
                <th>postal code</th>
                <th>country</th>
                <th>sales rep employee number</th>
                <th>credit limit</th>
                <th>Tùy chọn</th>
              </tr>
            </thead>
          </table>

        </div>
        <!-- Date -->
        <!-- Main content -->
        <!-- Main content -->
        <!-- Main content -->
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2023 <a href="https://adminlte.io">Devcamp.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->
  <!-- modal -->
  <!-- Update customer modal (sửa album) -->
  <div>
    <div id="update-customer-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Chi tiết customer </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <!-- form customer -->
              <div class="jumbotron container">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-customer-code-sua">Mã Customer</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-customer-code-sua" name="maVouchers" placeholder="Customer code"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-discount-sua">Phần trăm giảm giá</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-discount-sua" name="discount" placeholder="Discount"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-note-sua">Hhhhhhh</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-note-sua" name="note" placeholder="Note" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-createDate-sua">Ngày Tạo</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="date" id="input-createDate-sua" name="createDate" placeholder="Create Date"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-updateDate-sua">Ngày sửa</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="date" id="input-updateDate-sua" name="updateDate" placeholder="Update Date"
                      class="form-control">
                  </div>
                </div>
              </div>

            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-update-diem">Update customer</button>
            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Confirm xóa customer</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa customer này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-customer">Xác nhận</button>
            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ </button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- insert modal (thêm album) -->
  <div>
    <div id="insert-sinh-vien-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Tạo mới customer </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <!-- form customer -->
              <div class="jumbotron container">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-customer-code-insert">last name</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-customer-code-insert" name="maVouchers" placeholder="Customer code"
                      class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-firstName">first name</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-firstName" name="discount" placeholder="Discount" class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-phoneNumber">phone number</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-phoneNumber" name="phoneNumber" placeholder="phoneNumber"
                      class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-address">address</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-address" name="note" placeholder="address" class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-city">city</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-city" name="note" placeholder="city" class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-state">state</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-state" name="note" placeholder="state" class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-postalCode">postal code</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-postalCode" name="note" placeholder="postalCode" class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-country">country</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-country" name="note" placeholder="country" class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-salesRepEmployeeNumber">sales rep employee number</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-salesRepEmployeeNumber" name="note"
                      placeholder="salesRepEmployeeNumber" class="form-control">
                  </div>
                </div>

                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-creditLimit">credit limit</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-creditLimit" name="creditLimit" placeholder="creditLimit"
                      class="form-control">
                  </div>
                </div>
              </div>

            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-insert-customer">Thêm customer</button>
            <button class="btn btn-secondary" id="btn-update-cancel-them" data-dismiss="modal">Hủy bỏ</button>

          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- .modal -->

  <!-- jQuery -->
  <script src="../plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="../plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- Select2 -->
  <script src="../plugins/select2/js/select2.full.min.js"></script>
  <!-- InputMask -->
  <script src="../plugins/moment/moment.min.js"></script>
  <script src="../plugins/inputmask/jquery.inputmask.min.js"></script>
  <!-- date-range-picker -->
  <script src="../plugins/daterangepicker/daterangepicker.js"></script>
  <!-- bootstrap color picker -->
  <script src="../plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js"></script>
  <!-- Tempusdominus Bootstrap 4 -->
  <script src="../plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="../dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="../dist/js/demo.js"></script>
  <!-- data table -->
  <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>

  <script>

    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL_VOUCHER = "http://localhost:8080/customers";
    var gId = "";
    var gStt = 0;  // khai báo số thứ tự ban đầu bằng 0;  tự reset sau mỗi lần đổ dữ liệu

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
      // khai báo nút sửa 
      $("#table-lich-su-hoc-tap").on("click", ".btn-edits", onSuaClick); // khai báo nút sửa   
      $("#table-lich-su-hoc-tap").on("click", ".btn-deletes", onXoaClick); // khai báo nút xóa
      $("#table-lich-su-hoc-tap").on("click", ".btn-customer-detail", detailvoucherClick); // khai báo nút detail customer modal
      $("#btn-them-customer").on("click", onAddAlbumClick); // khai báo nút thêm customer 
      $("#btn-modal-insert-customer").on("click", onInsertVoucherClick);   // nút xác nhận thêm  
      $("#btn-modal-update-diem").on("click", onModalUpdatevoucherClick);  // khao báo chấp nhận update customer
      $("#btn-confirm-delete-customer").on("click", onConfirmDeletevoucherClick);     // khai báo nút xác nhận xóa
      $(".btn-loc-du-lieu").on("click", locDuLieu);     // khai báo nút 

    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict"
      console.log("đã load xong thẻ body ");
      // phần đổ dữ liệu cho ô select . gán dữ liệu vào biến toàn cục
      // load data table jquery nhưng chưa truyền dữ liệu 
      khoiTaoDataTable();
      //b1 bỏ qua
      //b2 bỏ qua
      //b3  call api && //b4 load data in table 
      callApiListvoucher(getInsertRowTable);
    }

    // khai báo sự kiện nút sửa 
    function onSuaClick() {

      console.log("ấn nút sửa ");
      $("#update-customer-modal").modal("show");  // hiện modal
      var vObject = readObjectRow(this);
      console.log("id là:  " + vObject.id);
      gId = vObject.id;

      // b3 . gọi api lấy object  
      var vObjectDatavoucher = null;
      getDataByID(vObject.id, function (pamramRes) {
        // b4 xử lý hiển thị  đổ dữ liệu lên modal 
        console.log(pamramRes);
        resertUpdateVoucherForm();   // xóa trắng trước khi load dữ liệu lên 
        loadDataInModalUpdatevoucher(pamramRes);

        return;
      });
    }
    // khai báo sự kiện nút xóa customer  
    function onXoaClick() {
      console.log("ấn nut xóa ");
      var vObject = readObjectRow(this);
      console.log("id là:  " + vObject.id);
      gId = vObject.id; // 
      $("#delete-confirm-modal").modal("show");  // hiện modal xóa 
    }
    // ấn nút detail src-customer-detail
    function detailvoucherClick() {
      // b1 lấy id theo dòng 
      console.log("ấn nut xóa ");
      var vObject = readObjectRow(this);
      console.log("id là:  " + vObject.id);
      gId = vObject.id; // 
      // gọi server lấy địa chỉ ảnh theo id 
      getApivoucherDetail(vObject.id);
      // đổi địa chỉ ảnh đó trong thẻ img có id src-customer-detail

      $("#detail-customer-modal").modal("show");  // hiện modal xóa 
    }


    // khai báo sự kiện nút thêm customer
    function onAddAlbumClick() {

      console.log("ấn nut add customer ");
      $("#insert-sinh-vien-modal").modal("show");  // hiện modal.
    }
    // khai báo nút insert customer (add customer);
    function onInsertVoucherClick() {
      console.log("ấn nút insert customer ");
      //04 bước xử lý sự kiện có gọi server
      // b1 thu thâpj dữ liệu
      var vObject = readDataModalInsertvoucher();  // đọc dữ liệu trên form modal sửa thông tin người dùng
      // b2 validate data
      var vResult = validateDataInsertvoucher(vObject);
      console.log("thêm customer ", vObject);
      // b3 call server
      if (vResult) {
        $.ajax({
          type: "POST",
          url: gBASE_URL_VOUCHER + "/create/",  // tham số cuối cùng là id của album
          data: JSON.stringify(vObject),
          contentType: "application/json",
          success: function (data) {
            console.log("đã thêm customer thành công");
            alert("Thêm customer thành công Id của bạn là  " + data.id);
            $("#insert-sinh-vien-modal").modal("hide"); //tắt Modal 
            callApiListvoucher(getInsertRowTable); //  load lại bảng danh sách vouchers
            resertCreateVoucherForm(); // xóa trắng dữ liệu 
          },
          error: function (e) {
            if (e.status == 422) {
              alert("lỗi trùng code customer" + e.responseText);
              return;
            }
            console.log(e);
            alert("quá trình thêm customer gặp sự cố" + e.responseText);
          }
        });
      }
      // b4
      console.log(vObject);
    }

    // khai baos nút xác nhận update  sửa customer
    function onModalUpdatevoucherClick() {
      console.log("ấn nut xác nhận update  customer ");
      //04 bước xử lý sự kiện có gọi server
      // b1 thu thâpj dữ liệu
      var vObject = readDataInModalUpdatevoucher();  // đọc dữ liệu trên form modal sửa thông tin người dùng
      // b2 validate data
      console.log(vObject);
      var vResult = validateDatavoucher(vObject);
      // b3 call server
      console.log("trước update: ", vObject);
      if (vResult) {
        updatevoucherById(vObject, function (pamramRes) {
          // b4 hiển thị font end 
          console.log("server update: ", pamramRes);
          alert("thông báo đã cập nhật thành công");
          $("#update-customer-modal").modal("hide"); //tắt Modal 
          callApiListvoucher(getInsertRowTable); //  load lại bảng danh sách vouchers
          resertCreateVoucherForm(); // xóa trắng dữ liệu 
        });
      }
    }
    // nút xác nhận xóa customer 
    function onConfirmDeletevoucherClick() {
      console.log("Xác nhận xóa ");
      // b3 gọi api để xóa customer theo iD 
      callApiDeletevoucher(function (paramRes) {
        // xử lý font end 
        alert("thông báo đã xóa customer thành công id là : " + gId);
        $("#delete-confirm-modal").modal("hide"); //tắt Modal 
        callApiListvoucher(getInsertRowTable); //  load lại bảng danh sách vouchers 
      });
    }
    //Lọc dữ liệu 
    function locDuLieu() {
      console.log("đã ấn nút lọc dữ liệu");
      // 4 bước xử lý dữ liệu 
      // b1 . đọc dữ liệu
      var vObject = getReadDataFiter();
      console.log("đối tượng sau khi đọc dữ liệu lọc", vObject);
      // bước 2 . kiểm tra bỏ qua 
      // bước 3 lọc 
      var vArrObject = getFilter(vObject);  // lọc nhiều phần tử 
      // bước 4 . xử lý font end 
      console.log("đối tượng sau khi Lọc dữ liệu lọc", vArrObject);
      getInsertRowTable(vArrObject);  // đổ dữ liệu đã lọc lên table
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    //            XỬ LÝ PHẦN ONPAGELOADING  
    // khởi tạo data table 
    function khoiTaoDataTable() {

      //   {
      //     "id": 103,
      //     "lastName": "Schmitt",
      //     "firstName": "Carine",
      //     "phoneNumber": "40.32.2555",
      //     "address": "54, rue Royale",
      //     "city": "Nantes",
      //     "state": "null",
      //     "postalCode": "44000",
      //     "country": "France",
      //     "salesRepEmployeeNumber": 1370,
      //     "creditLimit": 21000
      // },
      /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
      $("#table-lich-su-hoc-tap").DataTable({

        columns: [
          { data: "stt" },
          { data: "lastName" },
          { data: "firstName" },
          { data: "phoneNumber" },
          { data: "address" },
          { data: "city" },
          { data: "state" },
          { data: "postalCode" },
          { data: "country" },
          { data: "salesRepEmployeeNumber" },
          { data: "creditLimit" },
          { data: "action" },

        ],
        columnDefs: [

          {
            targets: 0, // cột age  gListMonHoc  
            render: function () {
              gStt++;
              return gStt;
            }
          },

          {
            targets: 11,
            defaultContent: '<i style="cursor: -webkit-grab; cursor: grab;" class="fa-solid fa-pencil   btn-edits" data-toggle="tooltip" data-placement="top" title="Sửa"></i>  &nbsp; &nbsp;' +
              '<i  style="cursor: -webkit-grab; cursor: grab;" class="fa-regular fa-trash-can btn-deletes" data-toggle="tooltip" data-placement="top" title="Xóa"></i>  &nbsp; &nbsp;',

          },
        ]
      });
    }
    //  gọi API load all vouchers      <i class="fa-regular fa-list-radio"></i>
    function callApiListvoucher(pramFunction) {
      // khai báo ajax jquery
      $.ajax({
        url: gBASE_URL_VOUCHER + "/all",
        type: "GET",
        dataType: "json",
        success: pramFunction,
        error: function (paramError) {
          console.log("lỗi khi gọi api All customer" + paramError.status);
        }
      });
    }
    // hàm thêm từng dòng dữ liệu vào   // hàm này chính là success
    function getInsertRowTable(paramRes) {
      console.log("đã load đến insert table");
      console.log(paramRes);
      var vTable = $("#table-lich-su-hoc-tap").DataTable();
      vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
      vTable.rows.add(paramRes);
      vTable.draw();
      gStt = 0; // quy 0 số thứ tự
      // đổ dữ liệu table xongg đổ dữ liệu lên modal

    }



    // lấy tất cả giá trị của 1 hàng tương ứng với nút bấm trên hàng đó 
    function readObjectRow(paramThis) {
      console.log(paramThis);
      var vRowClick = $(paramThis).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
      var vTable = $("#table-lich-su-hoc-tap").DataTable();   // tạo biến đến dataTable 
      var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
      return vDataRow.data();
    }
    // ........................ [nút insert customer in modal].......................
    //04 bước xử lý sự kiện có gọi server
    // b1 thu thâpj dữ liệu và trả về object chứa thông tin người dùng 


    //   {
    // 
    // 	"lastName": "Berglund",
    // 	"firstName": "Christina",
    // 	"phoneNumber": "0921-12 3555",
    // 	"address": "Berguvsvägen 8",
    // 	"city": "Luleå",
    // 	"state": "null",
    // 	"postalCode": "S-958 22",
    // 	"country": "Sweden",
    // 	"salesRepEmployeeNumber": 1504,
    // 	"creditLimit": 53100
    // }


    function readDataModalInsertvoucher() {
      var vObjectCustomer = {
        lastName: "",
        firstName: "",
        phoneNumber: "",
        address: "",
        city: "",
        state: "",
        postalCode: "",
        country: "",
        salesRepEmployeeNumber: "",
        creditLimit: ""
      }
      // gán giá trị cho đối tượng 
      vObjectCustomer.lastName = $("#input-customer-code-insert").val().trim();
      vObjectCustomer.firstName = $("#input-firstName").val().trim();
      vObjectCustomer.phoneNumber = $("#input-phoneNumber").val().trim();
      vObjectCustomer.address = $("#input-address").val().trim();
      vObjectCustomer.city = $("#input-city").val().trim();
      vObjectCustomer.state = $("#input-state").val().trim();
      vObjectCustomer.postalCode = $("#input-postalCode").val().trim();
      vObjectCustomer.country = $("#input-country").val().trim();
      vObjectCustomer.salesRepEmployeeNumber = $("#input-salesRepEmployeeNumber").val().trim();
      vObjectCustomer.creditLimit = $("#input-creditLimit").val().trim();

      return vObjectCustomer;
    }
    // b2 validate data
    // kiểm tra xem người dùng có nhập hay k . nếu không nhập thì nhắc nhở người dùng
    function validateDataInsertvoucher(vObjectCustomer) {
      if (vObjectCustomer.lastName === "") {
        alert("Mã customer phải được nhập  ");
        return false;
      }
      if (vObjectCustomer.firstName === "") {
        alert("firstName không được để trống ");
        return false;
      }
      if (vObjectCustomer.phoneNumber === "") {
        alert("phoneNumber không được để trống ");
        return false;
      }
      if (vObjectCustomer.address === "") {
        alert("address không được để trống ");
        return false;
      }
      if (vObjectCustomer.city === "") {
        alert("city không được để trống ");
        return false;
      }
      if (vObjectCustomer.state === "") {
        alert("state không được để trống ");
        return false;
      }
      if (vObjectCustomer.postalCode === "") {
        alert("postalCode không được để trống ");
        return false;
      }
      if (vObjectCustomer.country === "") {
        alert("country không được để trống ");
        return false;
      }
      if (vObjectCustomer.salesRepEmployeeNumber === "") {
        alert("salesRepEmployeeNumber không được để trống ");
        return false;
      }

      if (vObjectCustomer.creditLimit === "") {
        alert("creditLimit không được để trống ");
        return false;
      }


      return true;
    }

    // hàm xóa trắng form create customer
    function resertCreateVoucherForm() {
      // gán giá trị cho đối tượng 
      $("#input-customer-code-insert").val("");
      $("#input-firstName").val("");
      $("#input-phoneNumber").val("");
      $("#input-address").val("");
      $("#input-city").val("");
      $("#input-state").val("");
      $("#input-postalCode").val("");
      $("#input-country").val("");
      $("#input-salesRepEmployeeNumber").val("");
      $("#input-creditLimit").val("");
    }
    // ......................[ xử lý nút edit . nút sửa ].....................
    // Mẫu gọi API Get customer by id
    function getDataByID(paramId, paramFunction) {
      $.ajax({
        url: gBASE_URL_VOUCHER + "/" + paramId,
        type: "GET",
        dataType: "json",
        //async: false,
        success: paramFunction,
        error: function (paramError) {
          console.log(paramError.status)
        },
      });
    }
    //load load dữ liệu lên fomr modal update
    function loadDataInModalUpdatevoucher(paramObject) {
      // Lấy ngày tháng cần đổ, ví dụ 1/5/2022
      const myDateNgayTao = new Date(paramObject.ngayTao);
      const myDateNgayCapNhap = new Date(paramObject.ngayCapNhat);

      // đổi từ id 
      $("#input-customer-code-sua").val(paramObject.maVoucher);
      $("#input-note-sua").val(paramObject.ghiChu);
      $("#input-discount-sua").val(paramObject.phanTramGiamGia);
      // nếu ngày tạo khác null thì mới đổ dữ liệu lên
      if (paramObject.ngayTao != null) {
        $("#input-createDate-sua").val(myDateNgayTao.toISOString().slice(0, 10));  // slice(0, 10)  cắt chuỗi từ 0 10.. ngày tháng nawmg trong 10 ký tự đầu
      }
      if (paramObject.ngayCapNhat != null) {
        $("#input-updateDate-sua").val(myDateNgayCapNhap.toISOString().slice(0, 10));
      }


      console.log("load xong  data update");

    }
    // hàm xóa trắng form update customer
    function resertUpdateVoucherForm() {
      $("#input-customer-code-sua").val("");
      $("#input-note-sua").val("");
      $("#input-discount-sua").val("");
      $("#input-createDate-sua").val("");
      $("#input-updateDate-sua").val("");
    }
    // ..................................[Nút update customer (sửa thông tin người dùng)].............
    //04 bước xử lý sự kiện có gọi server
    // b1 thu thâpj dữ liệu
    function readDataInModalUpdatevoucher() {
      var vObjectCustomer = {
        maVoucher: "",
        phanTramGiamGia: "",
        ghiChu: "",
        ngayTao: "",
        ngayCapNhat: ""
      }
      // gán giá trị cho đối tượng 
      vObjectCustomer.maVoucher = $("#input-customer-code-sua").val().trim();
      vObjectCustomer.ghiChu = $("#input-note-sua").val().trim();
      vObjectCustomer.phanTramGiamGia = $("#input-discount-sua").val().trim();
      vObjectCustomer.ngayTao = $("#input-createDate-sua").val();
      vObjectCustomer.ngayCapNhat = $("#input-updateDate-sua").val();  // trường này để set thêm customer vào 1 album nào đó 
      return vObjectCustomer;
    }
    // b2 validate data
    function validateDatavoucher(paramObject) {
      if (paramObject.maVoucher === "" || paramObject.maVoucher.length < 5) {
        alert("Mã customer phải được nhập . và phải từ 5 ký tự trở lên ");
        return false;
      }
      if (paramObject.phanTramGiamGia === "") {
        alert("phần trăm giảm giá không được để trống và phải là số");
        return false;
      }


      return true;
    }

    // b3 call server
    //  gọi API Update customer by Id
    function updatevoucherById(paramObject, paramFunction) {
      $.ajax({
        url: gBASE_URL_VOUCHER + "/update/" + gId,
        type: "PUT",
        contentType: "application/json;charset=UTF-8",
        data: JSON.stringify(paramObject),
        success: paramFunction,
        error: function (paramError) {
          console.log(paramError.status);
          console.log(paramError);
          alert("thông báo đã cập nhật không thành công");

        }
      });
    }
    // ................... [nút xác nhận xóa customer]............
    function callApiDeletevoucher(paramFunciton) {
      $.ajax({
        url: gBASE_URL_VOUCHER + "/delete/" + gId,
        type: "DELETE",
        // dataType: "json",
        success: paramFunciton,
        error: function (paramError) {
          console.log(paramError.status);
          alert("Hệ thống chưa thể xóa customer do trục trặc kỹ thuật  " + paramError.status);
          $("#delete-confirm-modal").modal("hide"); //tắt Modal 
        },
      });
    }








  </script>
</body>

</html>